# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
#
# Check all requirements for facts
#
# rubocop: disable Style/MixinUsage
def pg_define_fact(fact_name, &block)
  require "#{File.dirname(__FILE__)}/fact"
  include PuppetX::Postgres::Fact

  Facter.add("pg_#{fact_name}") do
    #
    # For now only accept these facts when the primary database is Postgres12
    #
    confine do
      Puppet.features.postgres? && Puppet.features.postgres_running?
    end
    pg_array_fact(:name => 'NAME', :db => 'db', &block)
  end
end
# rubocop: enable Style/MixinUsage
