# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
require 'digest'
module PuppetX
  module EnterpriseModules
    module Postgres
      # docs
      module Password
        # rubocop: disable Naming/PredicateName
        def is_password_hash
          sql("SELECT rolpassword FROM pg_authid where rolname='#{resource[:role_name]}'", :instance => resource[:instance], :db => 'postgres').first['rolpassword']
        end
        # rubocop: enable Naming/PredicateName

        def should_password_hash
          "md5#{hashed_password}"
        end

        def hashed_password
          Digest::MD5.hexdigest("#{value}#{resource[:role_name]}")
        end
      end
    end
  end
end
