# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# docs
module PuppetX
  module EnterpriseModules
    module Postgres
      # A property that will issue a warning when the is value is different from the should
      class ReadOnlyProperty < Puppet::Property
        # rubocop: disable Naming/MethodParameterName
        def insync?(is)
          Puppet.warning "#{path} is a puppet read-only property; unable to change from #{is} to #{should}." if is.to_s != should.to_s
          true
        end
        # rubocop: enable Naming/MethodParameterName
      end
    end
  end
end
