# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/postgres/access'

module PuppetX
  module EnterpriseModules
    module Postgres
      # Docs
      module TitleParser
        include PuppetX::EnterpriseModules::Postgres::Access

        def map_title_to_instance(*attributes, &proc)
          map_title_to_instance_internal(*(attributes << :instance), &proc)
        end

        # @private
        def map_title_to_instance_internal(*attributes, &proc)
          instance_parameter = attributes.pop
          base_regexp = proc ? yield : /(.+)/
          without_instance_regexp = Regexp.new("^(#{base_regexp.source})$")
          with_instance_regexp    = Regexp.new("^(#{base_regexp.source}@(.*))$")
          map_titles_to_attributes([
                                     with_instance_regexp, [:name] + attributes + [instance_parameter],
                                     without_instance_regexp, [:name] + attributes
                                   ])
        end
      end
    end
  end
end
